

                               
![](docs/assets/logo.png)



![PyPI](https://img.shields.io/pypi/v/Oz-Engine?label=Oz-Engine%20pypi)

# Oz-Engine, a **Text-Based Game Engine** Made Using **Python**.

**Oz-Engine** is a Engine that allow to control **characters** individually like **sprites** you would have in a classic game engine.
It can be used to make games in:
* **Terminal**  
* **Discord** 
* [**Microbit**](https://github.com/menitoon/Oz-Engine-Microbit-version)
* **Any matrix-led screen**


![](https://thumbs.gfycat.com/ScientificTatteredCardinal-size_restricted.gif) 
![](https://thumbs.gfycat.com/AcclaimedAlienatedGiraffe-size_restricted.gif)  
![](https://cdn.discordapp.com/attachments/1075772045142528060/1113350382400319508/2023-05-31_07-38-59.gif)

_Games like **[Connect-4](https://github.com/menitoon/Connect-4-with-Oz-Engine), [Snake](https://github.com/menitoon/Snake-Microbit-with-Oz-Engine) and [Conway's Game of Life](https://github.com/menitoon/Conway-s-Game-of-Life-with-Oz-Engine)** have been made in Oz-Engine._

## Features

* Sprites
* Handling Collision 
* Calling Groups 
* Camera Support 
* Custom Sprite Type 
* Flexible Render Target
* Structure Support (images made of multiple characters)

(You can either play in the **console** or on a **matrix-led screen**) 
![](https://cdn.discordapp.com/attachments/958679110316617748/1079378617328468119/2explanation.png)

## Startup

In **CommandLine** type this:

``$ pip install Oz-Engine``
 
 Then **import** it at the top of your project like so:
 ```python 
 import OzEngine as oz 
 ```


## **Using** the **Engine**

******If you want to get started and learn how to use it go [here](https://github.com/menitoon/Oz-Engine/wiki).******


## License

Distributed under the GPL-3.0 license check ``LICENSE.txt`` for more information.

## Contributing 

Contributions to this project are greatly apreciated, check the [Contribution Guidelines](https://github.com/menitoon/Oz-Engine/blob/main/CONTRIBUTING.md)


__If you want to support me and the project please consider leaving a star ⭐  as it just makes my day better !__
